<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8">

    <link rel="stylesheet" href="bootstrap.min.css">
    <script src="cropper.js"></script>
    <link rel="stylesheet" href="cropper.css">
    <link rel="stylesheet" href="style.css">

<style>
html, body {margin: 0; height: 100%; overflow: hidden}

@import url("https://fonts.googleapis.com/css?family=Roboto");

@font-face {
    font-family: myFirstFont;
    src:url("meera.tff");
}
#return_text{
    font-family: myFirstFont;
}
input[type=radio] {
  position: absolute;
  visibility: hidden;
  display: none;
}

label {
  color: #56d9e8;
  display: inline-block;
  cursor: pointer;
  font-weight: bold;
  padding: 5px 20px;
}

input[type=radio]:checked + label {
  color: white;
  background: #56d9e8;
}

label + input[type=radio] + label {
}

.radio-group {
  border: solid 3px #56d9e8;
  display: inline-block;
  border-radius: 10px;
  overflow: hidden;
}
label{
  margin-bottom:0px;
}
</style>
    <title>SRR OCR</title>
  </head>
  <body>
      <div id="main_body" style="max-height:100%;overflow-x:hidden;;overflow-y:scroll;">
      <div class="row" style="overflow-y:hidden">
	<div id="contain" class="col-md-4">

		<!--icfoss logo -->
		<div style="padding-left:27%;">
			<img src="picture.jpg" style="max-width:190px">
<br><br>
<button onclick="full_reset()"  class="btn btn-danger" style="margin-left:17.5%">Reset &#8634;</button> 
		</div>


		<!--upload area -->
		<div id="upload_area" >
			
			<div style="padding-top:45%;text-align:center;">
			<button onclick="upload()"  class="btn yellow"> UPLOAD FILE </button>
	<input style="display:none" id="file" type="file" name="filename" onchange="readURL(this);" accept="image/gif, image/jpeg, image/png">

			<p style="color:red;font-size:10px;padding-top:10px"><b>ONLY .PNG, .JPG, .JPEG FILES ACCEPTED</b></p>
			</div>
			<div id="overlay2">
				  <div id="text2"><img class="" src="loading.gif" height="50" width="50"><br>Setting Up! Please Wait.</div>
			</div>
		</div>

		<!--config area -->
		<div id="config_area" style="display:none">
			<!-- work area -->
			<div style="padding-top:15%;text-align:center;">
			<form>
				<div class="col-md-12" style="text-align:center;">
					<h5>Select Language: </h5>
				</div>
 				<div class="radio-group">
					<input type="radio" id="option-one" name="selector" value="mal_model"><label id="first_label" for="option-one"  onclick="model_change()">MAL</label>
					<input type="radio" id="option-two" name="selector" value="mal_ascii_model"><label for="option-two"  onclick="model_change()">MAL-ASCII</label>
					<input type="radio" id="option-three" name="selector"  value="eng_model"><label for="option-three"  onclick="model_change()">ENG</label>
  				</div>
   			</form>
			<br><br>
			<div class="row">
				<div class="col-md-8" style="text-align:center;padding-top:12px;">
					<h5>Image Threshold: </h5>
				</div>
				<div  class="col-md-4" style="text-align:left">
					<h1 id="thresh_val">127</h1>
				</div>
				<div class="slidecontainer">
					<input type="range" min="120" max="254" value="127" class="slider" id="imgrange">
				</div>
			</div>
			<br>
			<div class="row">
				<div class="col-md-8" style="text-align:center;padding-top:12px;">
					<h5>Word Spot Threshold: </h5>
				</div>
				<div  class="col-md-4" style="text-align:left">
					<h1 id="word_val">10</h1>
				</div>
			</div>			
			<div class="slidecontainer">
				<input type="range" min="1" max="10" value="3" class="slider" id="myRange">
			</div>
			<br>
				<button onclick="rotate_left()" class="btn btn-primary">LEFT</button>
				<button onclick="rotate_right()" class="btn btn-primary">RIGHT</button>

			<br><br><br>
				<button onclick="run_recognition()"  class="btn btn-success"> RUN RECOGNITION</button>
			</div>
			<!--over lay-->
			<div id="overlay">
				  <div id="text"><img class="" src="loading.gif" height="50" width="50"><br><h2 id="display_head">Scanning</h2></div>
			</div>

			
		</div>

		<div id="display_area" style="display:none" >
			<!-- work area -->
			<div style="padding-top:20%;text-align:center;">
				<textarea id="return_text" rows="10" cols="50"></textarea>
				<br><br>
				<div class="row">
					<div class="col-md-6">
						<button onclick="save()" class="btn btn-success"> SAVE</button>
					</div>
					<div class="col-md-6">
						<button onclick="reset()" class="btn btn-danger"> DROP</button>
					</div>
				</div>
			</div>
			<div id="overlay1">
				  <div id="text1"><br><br><br><br>
					File is Saved!<br>
					<button onclick="retu()" class="btn btn-success" >RETURN</button>	
				  </div>
			</div>
		</div>
		
	</div>

<div class="col-md-8"style="padding-top:1.5%;">
	<div style="border: 2px solid black;overflow-y:hidden;overflow-x:hidden;">
		<img id="image" src="123.jpg">
		<img id="original_image" src="123.jpg" style="display:none">
		<img id="restored_origin" src="123.jpg" style="display:none">
	</div>
<canvas id="imageCanvas" style="display:none;opacity:1"><canvas>      
</div>
</div>
     <canvas id="imageCanvas1" style="display:none;opacity:1"><canvas> 
      
</div>

  </body>


<script >
function model_change(){  //changing the model from mal to eng or masl-ascii
	var ele = document.getElementById("overlay")
	var rotate_data = 0
	var ele2 = document.getElementById("display_head")
	ele2.innerHTML = "Loading"
	ele.style.display = "block";


	setTimeout(function(){

		if (document.getElementById('option-one').checked) {
			  rate_value = document.getElementById('option-one').value;
						console.log(rate_value)
			      client.invoke("change_model", rate_value, (error, res) => { //tcp call for changing model to mal
					if(error) {
			    			console.error(error)
			  		} else {
						document.getElementById("overlay").style.display = "none";
			 		}
			})
		}

		else if (document.getElementById('option-two').checked) {
			  rate_value = document.getElementById('option-two').value;
						console.log(rate_value)
			     client.invoke("change_model", rate_value, (error, res) => { //tcp call for changing model to mal-ascii
					if(error) {
			    			console.error(error)
			  		} else {
						console.log(res)
						document.getElementById("overlay").style.display = "none";
			 		}
				})
			}
		else {
			  rate_value = document.getElementById('option-three').value;
						console.log(rate_value)
			      client.invoke("change_model", rate_value, (error, res) => { //tcp call for changing model to eng
					if(error) {
			    			console.error(error)
			  		} else {
						console.log(res)
						document.getElementById("overlay").style.display = "none";

			 		}
				})
		}
	   },50)
}
var fs = require('fs');
const zerorpc = require("zerorpc")
let client = new zerorpc.Client();
client.connect("tcp://127.0.0.1:4242"); // initiating the tcp
client.invoke("echo", "server ready", (error, res) => { 
	  if(error || res !== 'server ready') {
	    	console.error(error)
	  } else {
	    	document.getElementById("overlay2").style.display = "none";
	    	console.log("server is ready")
	  }
})

const cv = require('./opencv.js');

document.getElementById("overlay2").style.display = "block";
    
var slider = document.getElementById("myRange");
var output = document.getElementById("word_val");
output.innerHTML = slider.value; // Display the default slider value
var upload_area = document.getElementById("upload_area");
var config_area = document.getElementById("config_area");
// Update the current slider value (each time you drag the slider handle)
slider.oninput = function() {
    output.innerHTML =  this.value;
    doc = document.getElementById('original_image')
    var int = parseInt(this.value)
    setTimeout(function(){word_thresh(doc,int)},50)
   //location to implement word thresholding function
}    

var slider2 = document.getElementById("imgrange");
var output2 = document.getElementById("thresh_val");
slider2.oninput = function() {  //threshold call upon changing input slider
    output2.innerHTML =  this.value;
    doc = document.getElementById('restored_origin')
    var int = parseInt(this.value)
    setTimeout(function(){apply_thresh(doc,int)},50)
   //location to implement word thresholding function
}   

function full_reset(){
	location.reload(true)  //total reset
}

function reset(){              //soft reset without reseting the image 
    document.getElementById("upload_area").style.display = "none";
    document.getElementById("config_area").style.display = "block";
 document.getElementById("display_area").style.display = "none";
 document.getElementById("return_text").value = '';
}

async function run_recognition() {
    get_data = cropper.getData()
    arr = [get_data['x'],get_data['y'],get_data['height'],get_data['width']]
    if ((arr[0] != 0) || (arr[1] != 0) || (arr[2] != 0) || (arr[3] != 0)){
var ele2 = document.getElementById("display_head")
ele2.innerHTML = "Scanning"                          //display scanning overlay
	    document.getElementById("overlay").style.display = "block";
	    var slider = document.getElementById("myRange");
	    var thresh = parseInt(slider.value)
	    org_doc = document.getElementById('original_image')
	    let img = cv.imread(org_doc);
	    let image = new cv.Mat();
	    let rect = new cv.Rect(arr[0],arr[1],arr[3],arr[2]);
	    let org_dst = img.roi(rect);   //cropping the selected region from cropper
	    cv.cvtColor(org_dst, image, cv.COLOR_RGBA2GRAY);
	    cv.threshold(image, image, 175, 255, cv.THRESH_BINARY_INV);
	    let dst = cv.Mat.zeros(image.cols, image.rows, cv.CV_8UC3);
	    let M = cv.Mat.ones(1, 3, cv.CV_8U);
	    let anchor = new cv.Point(-1, -1);
	    cv.dilate(image, image, M, anchor, thresh, cv.BORDER_CONSTANT, cv.morphologyDefaultBorderValue());
	    let contours = new cv.MatVector();
	    let hierarchy = new cv.Mat();
	    cv.findContours(image, contours, hierarchy, cv.RETR_TREE, cv.CHAIN_APPROX_SIMPLE);
	    cv.cvtColor(org_dst, org_dst, cv.COLOR_RGBA2RGB);  // found words inside the selected region
	    let org_dst2 = org_dst.clone()
	    var arr = []
            var cropped_data = []
	    for (let i = 0; i < contours.size(); ++i) { // looping through word crops
		let hier = hierarchy.intPtr(0, i)
		if (hier[3] == -1){ 
			let cnt = contours.get(i);
			let rect = cv.boundingRect(cnt);
			if(rect.height > 5){
				arr.push([rect.x,rect.y,rect.width,rect.height])
			}
		}
	    }
		    arr = arr.sort((a, b) => a[3] - b[3]) // sorting based on height
                    sliced_avg_arr =arr.slice(Math.floor(arr.length*0.90),Math.floor(arr.length*0.98))
		    var sum = 0;
		    for( var i = 0; i < sliced_avg_arr.length; i++ ){
		       sum += parseInt( sliced_avg_arr[i][3], 10 ); //don't forget to add the base
		    }
		    sliced_avg_height = Math.round(sum/sliced_avg_arr.length) // this region crops these words and handle the sentences
		    if (sliced_avg_height){
			sliced_avg_height = sliced_avg_height
		    }else{
			sliced_avg_height = 0
			}
		    console.log(sliced_avg_height)
                    let color = new cv.Scalar(255,0,0);
		    for (let i = 0; i < arr.length; ++i) {
                        if (arr[i][3] > sliced_avg_height*0.3){
				if (sliced_avg_height >arr[i][3]){
					upper = arr[i][1]
					num  = sliced_avg_height - arr[i][3]
					num_by_2 = Math.round(num/2)
					if ((arr[i][1]-num_by_2)>0){
						upper = arr[i][1]-num_by_2
					}

					cropped_data.push([arr[i][0],upper,arr[i][2],arr[i][3] + 2*num_by_2,arr[i][2],arr[i][3]])		
				}else{
					cropped_data.push([arr[i][0],arr[i][1],arr[i][2],arr[i][3],arr[i][2],arr[i][3]])		
				}
			}
		    }
	    cv.imshow('imageCanvas1', org_dst2);
	    cv.imshow('imageCanvas', image);
	    var canvas = document.getElementById('imageCanvas1');
	    dataUrl = canvas.toDataURL();
	    console.log(['ml',arr,thresh])

	if (document.getElementById('option-one').checked) {
		lang = "mal_model"
		}
	else if (document.getElementById('option-two').checked) {
		lang = "mal_ascii_model"
		}
	else {
		lang = "eng_model"
		}

	    client.invoke("recognition", [dataUrl,lang,cropped_data,thresh], (error, res) => { //tcp call to check for recognition
				if(error) {
		    			console.error(error)
					overlay_off(error)
		  		} else {
					console.log(res)
					overlay_off(res)
		 		}
			})
 //location to implement recognition function
	}else{
	alert('No crop selected!')
}
}
function overlay1_on() {
    document.getElementById("overlay1").style.display = "block";
}

function apply_thresh(res_img,thr){ // image thresholding, called upmon moving the threshold slider
                let img = cv.imread(res_img);
		org_doc = document.getElementById('original_image')
		let image = new cv.Mat();
                cv.cvtColor(img, image, cv.COLOR_RGBA2GRAY);
                cv.threshold(image, image, thr, 255, cv.THRESH_BINARY);
                cv.imshow('imageCanvas', image);
                var canvas = document.getElementById('imageCanvas');
                dataUrl = canvas.toDataURL();
                org_doc.src =  dataUrl
		cropper.replace(dataUrl)
		setTimeout(function(){ cropper.move(0,10000) }, 100);
}

function overlay_off(res) { // function for handling the result of recognition
    	document.getElementById("overlay").style.display = "none";
    	document.getElementById("config_area").style.display = "none";
 	document.getElementById("display_area").style.display = "block";

	if (document.getElementById('option-one').checked){
		 var new_val = res
		 document.getElementById("return_text").value = new_val;
	}else{
	 	document.getElementById("return_text").value = res;
	}
}

function overlay1_off() {
    document.getElementById("overlay1").style.display = "none";

}


function readURL(input) { //file input
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
		doc = document.getElementById('image')
                doc.src =  e.target.result
		org_doc = document.getElementById('original_image')
		org_doc1 = document.getElementById('restored_origin')
                org_doc.src =  e.target.result
                org_doc1.src =  e.target.result
		upload_area.style.display = 'none';
		config_area.style.display = 'block';
		setTimeout(function(){ cropper.move(0,10000) }, 100);
		baseString = reader.result;
setTimeout(function(){document.getElementById('first_label').click()},50)
		setTimeout(function(){word_thresh(doc,3)},100)

            };
            	reader.readAsDataURL(input.files[0]);

		
        }
    }    
var x = document.getElementById("main_body");
var y = document.getElementById("contain");
x.onscroll = function(e) {

y.style.paddingTop = x.scrollTop+"px";
}

let cropped_data = []
function word_thresh(image_element,thresh){ // handling the word thresholding and bounding box input.

            if(true){

                    let img = cv.imread(image_element);
		    let image = new cv.Mat();
                    cv.cvtColor(img, image, cv.COLOR_RGBA2GRAY);
                    cv.threshold(image, image, 175, 255, cv.THRESH_BINARY_INV);
		    let dst = cv.Mat.zeros(image.cols, image.rows, cv.CV_8UC3);

                    let M = cv.Mat.ones(1, 3, cv.CV_8U);
                    let anchor = new cv.Point(-1, -1);
                    cv.dilate(image, image, M, anchor, thresh, cv.BORDER_CONSTANT, cv.morphologyDefaultBorderValue());
   		    let contours = new cv.MatVector();
		    let hierarchy = new cv.Mat();
                    cv.findContours(image, contours, hierarchy, cv.RETR_TREE, cv.CHAIN_APPROX_SIMPLE);
		    cv.cvtColor(img, img, cv.COLOR_RGBA2RGB);
		    var arr = []
		    for (let i = 0; i < contours.size(); ++i) {
			    let hier = hierarchy.intPtr(0, i)

			    if (hier[3] == -1){ 
			    let color = new cv.Scalar(255,0,0);
			    let cnt = contours.get(i);
			let rect = cv.boundingRect(cnt);
			let point1 = new cv.Point(rect.x, rect.y);
			let point2 = new cv.Point(rect.x + rect.width, rect.y + rect.height);
                        if(rect.height > 5){
				cv.rectangle(img, point1, point2, color, 1, cv.LINE_8, 0);
			}
		    }

		}   
                    
                    cv.imshow('imageCanvas', img);
                    var canvas = document.getElementById('imageCanvas');
                    dataUrl = canvas.toDataURL();
                    image.delete();
		    cropper.replace(dataUrl)
		    setTimeout(function(){ cropper.move(0,10000) }, 100);
	 }
		
}
    
var image = document.getElementById('image');

const cropper = new Cropper(image, { //cropper settings
  viewMode: 3,
  autoCrop: false,
  dragMode: 'move',
  rotatable: true,
  zoom: function(e){
    var ratio = Math.round(2 * 1000)/10;
  }
});

var rotate_right = function(){
cropper.rotate(0.5)

}

var rotate_left = function(){
cropper.rotate(-0.5)
}

var save = function(){
    overlay1_on()
    var content = document.getElementById("return_text").value;

    try { fs.writeFileSync('myfile.txt', content, 'utf-8'); }
    catch(e) { alert('Failed to save the file !'); }
}

var retu = function(){
    overlay1_off()
} 
setTimeout(function(){ cropper.move(0,10000) }, 100);

var testfun = function(){
    cropper.setDragMode('none')
}


var upload  = function(){
	f = document.getElementById('file')
	f.click()
}




  
   
   
</script>
</html>
